/*
	Copyright (C) 2005 Christopher E. Miller
	
	This software is provided 'as-is', without any express or implied
	warranty.  In no event will the authors be held liable for any damages
	arising from the use of this software.
	
	Permission is granted to anyone to use this software for any purpose,
	including commercial applications, and to alter it and redistribute it
	freely, subject to the following restrictions:
	
	1. The origin of this software must not be misrepresented; you must not
	   claim that you wrote the original software. If you use this software
	   in a product, an acknowledgment in the product documentation would be
	   appreciated but is not required.
	2. Altered source versions must be plainly marked as such, and must not be
	   misrepresented as being the original software.
	3. This notice may not be removed or altered from any source distribution.
*/

private import dfl.all;

private import irclib.dflclient;


class ChatInfo: Form
{
	TextBox serverBox, nickBox, fullNameBox, userBox, chanBox;
	Button connectBtn;
	
	char[] tserver, tnick, tfullName, tuser, tchan;
	
	this()
	{
		initializeChatInfo();
		
		dialogResult = DialogResult.CANCEL;
		icon = null;
		suspendLayout();
		
		with(new Label)
		{
			location = Point(8, 12);
			size = Size(72, 16);
			text = "&Server:";
			parent = this;
		}
		
		with(serverBox = new TextBox)
		{
			location = Point(88, 8);
			size = Size(176, 20);
			text = "irc.freenode.net";
			parent = this;
		}
		
		with(new Label)
		{
			location = Point(8, 52);
			size = Size(80, 16);
			text = "&Nickname:";
			parent = this;
		}
		
		with(nickBox = new TextBox)
		{
			location = Point(88, 48);
			size = Size(176, 20);
			parent = this;
		}
		
		with(new Label)
		{
			location = Point(8, 84);
			size = Size(72, 16);
			text = "&Full name:";
			parent = this;
		}
		
		with(fullNameBox = new TextBox)
		{
			location = Point(88, 80);
			size = Size(176, 20);
			text = DflIrcClient.VERSION;
			parent = this;
		}
		
		with(new Label)
		{
			location = Point(8, 116);
			size = Size(64, 16);
			text = "&Email/user:";
			parent = this;
		}
		
		with(userBox = new TextBox)
		{
			location = Point(88, 112);
			size = Size(176, 20);
			text = "mrfoo";
			parent = this;
		}
		
		with(new Label)
		{
			location = Point(8, 156);
			size = Size(56, 16);
			text = "&Channel:";
			parent = this;
		}
		
		with(chanBox = new TextBox)
		{
			location = Point(88, 152);
			size = Size(176, 20);
			text = "#DFL";
			parent = this;
		}
		
		with(connectBtn = new Button)
		{
			location = Point(184, 184);
			size = Size(80, 24);
			text = "Connect!";
			parent = this;
			
			click ~= &connectBtn_click;
		}
		
		acceptButton = connectBtn;
		
		resumeLayout(false);
	}
	
	
	private void connectBtn_click(Object sender, EventArgs ea)
	{
		if(nickBox.textLength)
		{
			tserver = serverBox.text;
			tnick = nickBox.text;
			tfullName = fullNameBox.text;
			tuser = userBox.text;
			tchan = chanBox.text;
			
			dialogResult = DialogResult.OK;
			hide();
		}
		else
		{
			nickBox.focus();
			throw new Exception("Invalid nickname.");
		}
	}
	
	
	protected override void onLoad(EventArgs ea)
	{
		nickBox.focus();
		
		super.onLoad(ea);
	}
	
	
	private void initializeChatInfo()
	{
		// Do not manually edit this block of code.
		//~DFL Designer 0.3 code begins here.
		
		//~DFL Form
		formBorderStyle = FormBorderStyle.FIXED_DIALOG;
		maximizeBox = false;
		minimizeBox = false;
		showInTaskbar = false;
		startPosition = FormStartPosition.CENTER_PARENT;
		text = "DFL IRC Information";
		clientSize = dfl.drawing.Size(274, 215);
		
		//~DFL Designer 0.3 code ends here.
	}
}

